import * as Types from "./types";
import { ClassProvider, FactoryProvider, InjectionToken, TokenProvider, ValueProvider } from "./providers";
import { RegistrationOptions, constructor } from "./types";
export declare class DependencyContainer implements Types.DependencyContainer {
    private parent;
    private _registry;
    constructor(parent?: DependencyContainer | undefined);
    register<T>(token: InjectionToken<T>, provider: ValueProvider<T>): DependencyContainer;
    register<T>(token: InjectionToken<T>, provider: FactoryProvider<T>): DependencyContainer;
    register<T>(token: InjectionToken<T>, provider: TokenProvider<T>, options?: RegistrationOptions): DependencyContainer;
    register<T>(token: InjectionToken<T>, provider: ClassProvider<T>, options?: RegistrationOptions): DependencyContainer;
    registerType<T>(from: InjectionToken<T>, to: InjectionToken<T>): DependencyContainer;
    registerInstance<T>(token: InjectionToken<T>, instance: T): DependencyContainer;
    registerSingleton<T>(from: InjectionToken<T>, to: InjectionToken<T>): DependencyContainer;
    registerSingleton<T>(token: constructor<T>): DependencyContainer;
    resolve<T>(token: InjectionToken<T>): T;
    isRegistered<T>(token: InjectionToken<T>): boolean;
    reset(): void;
    createChildContainer(): Types.DependencyContainer;
    private getRegistration<T>(token);
    private construct<T>(ctor);
}
export declare const typeInfo: Map<Types.constructor<any>, any[]>;
export declare const instance: Types.DependencyContainer;
